/*!
 *  @file HostProtocol.h
 *
 * 	serial communication protocol, words based, packets with a CRC, codes as readable HEX with LF as en of packet deliminator
 * *
 *	BSD license (see license.txt)
 */

#ifndef _HOST_PROTOCOL_H
#define _HOST_PROTOCOL_H

#include "Arduino.h"

//#define HOSTmessageMaxLength (200+3)
#define HOSTmessageMaxLength (512-3)

#define NREF 300.0
#define IREF 4000.0
//#define MREF 1638.4
#define MREF 8192.0

extern char HOSTresp[];
extern int haveReply;
extern int ri, rj, rk, rm, rn, rt;
extern int new_ijkmnt; 

extern int16_t Xcorr_Velocity_as_int16;
extern int16_t Xcorr_Corr_Coeff_as_int16;
extern int16_t Spare3;
extern int16_t FIFO_delay_D_to_Bit;

extern uint16_t our_address;

void ParseHOSTcharacter (char ch);

void push_10ms_values_in_elastic_buffer ();

#endif
