#ifndef __DIRCALC_H__
#define __DIRCALC_H__

typedef struct
{
    float X;
    float Y;
    float Z;
} Three_D_vector_t;

typedef struct
{
    Three_D_vector_t AccelsVector;  
    Three_D_vector_t MagneticsVector;  

    Three_D_vector_t SquaredAccelsVector;  
    Three_D_vector_t SquaredMagneticsVector;  

    float SquaredRoot_SumOfSquared_AccelComponents;
    float SquaredRoot_SumOfSquared_MagenticComponents;
} TriGonioFloats_t;

#define GX TriGonioFloats->AccelsVector.X
#define GY TriGonioFloats->AccelsVector.Y
#define GZ TriGonioFloats->AccelsVector.Z

#define MX TriGonioFloats->MagneticsVector.X
#define MY TriGonioFloats->MagneticsVector.Y
#define MZ TriGonioFloats->MagneticsVector.Z

#define GX2 TriGonioFloats->SquaredAccelsVector.X
#define GY2 TriGonioFloats->SquaredAccelsVector.Y
#define GZ2 TriGonioFloats->SquaredAccelsVector.Z
#define MX2 TriGonioFloats->SquaredMagneticsVector.X
#define MY2 TriGonioFloats->SquaredMagneticsVector.Y
#define MZ2 TriGonioFloats->SquaredMagneticsVector.Z

#define SQRTGxyz2 TriGonioFloats->SquaredRoot_SumOfSquared_AccelComponents
#define SQRTMxyz2 TriGonioFloats->SquaredRoot_SumOfSquared_MagenticComponents

extern TriGonioFloats_t TriGonioFloats;

void normalise_to_one_dot_zero_magnitude (Three_D_vector_t *v);

void populate_TriGonioFloats_from_3Daccel_and_3Dmag (TriGonioFloats_t *TriGonioFloats, Three_D_vector_t *AccelSensors3D, Three_D_vector_t *MagneticSensors3D);

float RadsToDegs(float x);
float CalculateDeltaAngle (float x_now, float x_previously);
float KeepAngleWithinPlusOrMinus180 (float x);
float mod360 (float x);
float RADtoDEG_convert__Limit0to360 (float x);
float atan2f_better (float y, float x);

float Azimuth(TriGonioFloats_t *TriGonioFloats);             
float DipAngle(TriGonioFloats_t *TriGonioFloats);          
float GravToolFace(TriGonioFloats_t *TriGonioFloats);      

float Inclination(TriGonioFloats_t *TriGonioFloats);       
float MagneticTF(TriGonioFloats_t *TriGonioFloats);                

float TotGravFld(TriGonioFloats_t *TriGonioFloats);        
float TotMagFld(TriGonioFloats_t *TriGonioFloats);         

int linear_exclusive_scaling(float data, float scale_factor, float low_limit,float high_limit);

#endif
